
#include <string.h>
//#include <ncurses.h>
#include <ctype.h>

#include "action.h"
#include "system.h"
#include "misc.h"
#include "bosh.h"

int action_set(char *actstring) {

  char *a,*v;
  int n, i, vo;

  /* work out attribute and value */
  a = actstring;
  v = strchr(a,'=');
  if(!v)
    return -1;
  *v = 0;
  v++;

  /* check its a valid action character. */
  if(isalpha(*a))
    n = toupper(*a) - 55; /* 55 = 'A' - 10 */
  else if(isdigit(*a))
    n = *a - 48;
  else
    return -1;

  bosh->action[n].dest = BOSH_ACTION_OUTPUT_NONE;
  vo = 0;
  if(v[0]=='[') {
  vo++;
  while(1) {
    if(!v[vo]) {
      break;
    }
    if(v[vo]==']') {
      vo++;
      break;
    }
    switch(vo) {
      case 1:
        switch(v[1]) {
          case BOSH_ACTION_OUTPUT_NONE:
          case BOSH_ACTION_OUTPUT_OVERWRITE:
          case BOSH_ACTION_OUTPUT_ADVANCE:
          case BOSH_ACTION_OUTPUT_ENDCURSES:
            bosh->action[n].dest = v[1];
            break;
          default:
            return -2;
            break;
        }
        vo++;
        break;
        case 2:
        if(v[vo]==':') {
          vo++;
          i=0;
          while(v[vo+i]!=']')
            i++;
          bosh->action[n].prompt = malloc(i+1);
          i=0;
          while(v[vo]!=']') {
            bosh->action[n].prompt[i] = v[vo];
            vo++;
            i++;
          }
          bosh->action[n].prompt[i] = 0;
        }
        break;
      }
    }
  }
  if(v[vo])
    bosh->action[n].command = strdup(v+vo);

  return 0;
}



int action_run(int act, char *param) {

  char *action = NULL, *seperator = NULL,*p;
  int dest,i,n=1;

  if(act==BOSH_ACTION_SPECIAL_SHOWCONF) {
    dest = BOSH_ACTION_OUTPUT_ADVANCE;
    if(confpath) {
      action = malloc(strlen(confpath)+7);
      if(action)
        sprintf(action,"cat '%s'",confpath);
    }
    if(!action)
      return -1;

  } else {

    if(bosh->cursorsize>1) {
      seperator = bosh->multilineseperator ? bosh->multilineseperator : "";
      for(i=0;i<bosh->cursorsize;i++) {
        p = list_get(bosh->buf,bosh->offset+bosh->cursor+i);
        if(!p)
          break;
        n += strlen(p) + strlen(seperator);
      }
      dollarbosh = malloc(n);
      if(!dollarbosh)
        return -1;
      *dollarbosh = 0;
      for(i=0;i<bosh->cursorsize;i++) {
        p = list_get(bosh->buf,bosh->offset+bosh->cursor+i);
        if(!p)
          break;
        sprintf(dollarbosh+strlen(dollarbosh),"%s%s",p,seperator);
      }
    }
    else {
      p = list_get(bosh->buf,bosh->offset+bosh->cursor);
      if(p)
        dollarbosh = strdup(p);
    }

    setenv("BOSH",dollarbosh,1);

    if(bosh->preaction)
      action = strdup2(bosh->preaction,bosh->action[act].command);
    else
      action = strdup(bosh->action[act].command);
    dest = bosh->action[act].dest;

    if(param) {
      setenv("BOSHPARAM",param,1);
      dollarboshparam = strdup(param);
    }
  }

  switch(dest) {
    case BOSH_ACTION_OUTPUT_OVERWRITE:
      bosh_pipe(bosh,action);
      break;

    case BOSH_ACTION_OUTPUT_ADVANCE:
      bosh = bosh_new();
      bosh->command = strdup(action);
      bosh_open(bosh);
      if(list_items(boshlist)>1) {
        bosh_free(list_get(boshlist,1));
        list_del(boshlist,1);    /* this needs to be corrected if we ever get actions spawning bosh configurations */
      }
      boshlistpos = 1;
      list_add(boshlist,bosh);
      break;

    case BOSH_ACTION_OUTPUT_ENDCURSES:
      endwin();
      system(action);
      if(bosh->refresh)
        bosh_open(bosh);
      bosh_redraw();
      break;

    case BOSH_ACTION_OUTPUT_NONE:
      system(action);
      if(bosh->refresh)
        bosh_open(bosh);
      break;

    default:
      break;
  }

  free(action);
  free(dollarbosh);
  free(dollarboshparam);
  dollarbosh = NULL;
  dollarboshparam = NULL;
  return 0;
}
